// DOS and Borland C++ specific part

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <alloc.h>
#include <math.h>
#include <ctype.h>


#define Malloc	farmalloc
#define Free	farfree
#define Memset	_fmemset
#define MemCopy _fmemcpy
#define StrCpy	_fstrcpy
#define StrCat	_fstrcat
#define StrCmp	_fstrcmp
#define StrNCmp	_fstrncmp
#define StrChr	_fstrchr
#define StrLen	_fstrlen
#define StrPbkr _fstrpbrk

#define StringSave(p) (p ? _StringSave(p) : NULL)
#define StrSave(p) _StringSave(p)
#define StringLen(p) (p ? StrLen(p) : 0)

#include "autodif.h"

/* Must be the same as in programs generated by contdiff.c */
extern FILE *MStream_;
extern FILE *FStream_;

#define DEB	0

#if DEB
  #define DTS 5000
  static void *d_Tab[DTS];
  static int d_Line[DTS];
  static void d_add(void *p, int line) {
    int i;
    for (i=0; i<DTS; i++)
      if (!d_Tab[i]) {
	d_Tab[i]=p;
	d_Line[i]=line;
	return;
      }
    fprintf(MStream_,"\n\n\n#error d_Tab is too small\n\n\n");
    fclose(MStream_);
    abort();
  }
  static void d_del(void *p) {
    int i;
    for (i=0; i<DTS; i++)
      if (d_Tab[i]==p) {
	d_Tab[i]=NULL;
	return;
      }
    fprintf(MStream_,"\n\n\n#error Cannot find %p in d_Tab\n\n\n",p);
    fclose(MStream_);
    abort();
  }
  static void d_check(void) {
    int i;
    for (i=0; i<DTS; i++)
      if (d_Tab[i]) {
	fprintf(MStream_,"\n#error Line %i='%s'",d_Line[i],d_Tab[i]);
      }
  }

#define MemNew(s) _MemNew(s,__LINE__)
#define MemNewN(s) _MemNewN(s,__LINE__)

#endif

#if DEB
  static void *_MemNew(int size, int line) {
#else
  void *MemNew(int size) {
#endif
  void *p;
    p=Malloc(size);
    if (!p) {
      fprintf(MStream_,"\n\n\n#error ===>Cannot MemNew(%i)\n\n\n",size);
      fclose(MStream_);
      abort();
    }
#if DEB
    d_add(p,line);
#endif
    return Memset(p,0,size);
}

#if DEB
  static void *_MemNewN(int size, int line) {
#else
  void *MemNewN(int size) {
#endif
  void *p;
    p=Malloc(size);
    if (!p) {
      fprintf(MStream_,"\n\n\n#error ===>Cannot MemNew(%i)\n\n\n",size);
      fclose(MStream_);
      abort();
    }
#if DEB
    d_add(p,line);
#endif
    return p;
}


#define _StringSave(p) _fstrdup(p)

#if DEB
  static void MemFree(void *p) {
    if (p) {
      d_del(p);
      Free(p);
    }
  }
#else
  #define MemFree(p) if (p) Free(p)
#endif

#include "autodif.c"


#if defined(_Windows) && defined(WIN16)
  #error This MUST be compiled by bcc only (otherwise it produced Windows version of tmp_der.exe)
  #error bcc -c -ml -O2 -P @respond.con -W- -WD- -WDE- -tDe -oautodif.obj autodif.cpp
#endif
